unit uoddfacesrvdb;

interface

uses
  Classes, SysUtils, ubtree;

type
  (**
  CREATE TABLE `ofe_individuos_235` (
      `nid` int(11) NOT NULL,
      `adn` varbinary(750) NOT NULL,
      `dtc` datetime NOT NULL,
      `dtu` datetime NOT NULL,
      `f_VE` double NOT NULL,
      `f_CVaR` double NOT NULL,
      `f_VaR` double NOT NULL,
      `f_Objetivo` double NOT NULL,
      `f_MIN` double NOT NULL,
      `f_MAX` double NOT NULL,
      `cnt_evaluaciones` int(11) NOT NULL,
      `detalle` blob NOT NULL, PRIMARY KEY (`nid`),
      UNIQUE KEY `iadn` (`adn`),
      KEY `ifo` (`f_Objetivo`)
   ) ENGINE=InnoDB DEFAULT CHARSET=latin1
  **)

  TIndividuoOddface = class( TItemBTree )
    nid: integer;
    adn: string;
    dtc: TDateTime;
    dtu: TDateTime;
    f_VE: double;
    f_CVaR: double;
    f_VaR: double;
    f_Objetivo: double;
    f_MIN: double;
    f_MAX: double;
    cnt_evaluaciones: integer;
    detalle: pointer;
  end;

  { T_fObjetivo_idx }
  T_fObjetivo_idx = class( TBTree )
    constructor Create;
    function compare(a, b: TItemBTree ): integer; override;
  end;

  { T_ADN_idx }
  T_ADN_idx = class( TBTree)
    constructor Create;
    function Compare( a, b: TItemBTree ): integer; override;
  end;


  { TOddFace_Individuos }

  TOddFace_Individuos = class( TList )
    nidProblema: integer;
    nextNid: integer;
    idx_fObjetivo: T_fObjetivo_idx;
    idx_ADN: T_ADN_idx;
    MaxPoblacion: integer;

    constructor Create( nidProblema: integer; MaxPoblacion: integer );
    procedure WriteToBin;
    destructor destroy; override;
  end;


implementation

{ TOddFace_Individuos }

constructor TOddFace_Individuos.Create(nidProblema: integer;
  MaxPoblacion: integer);
begin
  Inherited Create;
  self.nidProblema:= nidProblema;
  self.MaxPoblacion:= MaxPoblacion;
  nextNid:= 0;

  idx_fObjetivo:= T_fObjetivo_idx.Create;
  idx_ADN:= T_ADN_idx.Create;

end;

procedure TOddFace_Individuos.WriteToBin;
begin

end;

destructor TOddFace_Individuos.destroy;
begin
  idx_fObjetivo.Free;
  idx_ADN.Free;
  inherited destroy;
end;

{ T_ADN_idx }

constructor T_ADN_idx.Create;
begin
  inherited Create( false );
end;

function T_ADN_idx.compare( a, b: TItemBTree ): integer;
begin
  if TIndividuoOddface(a).adn < TIndividuoOddface(b).adn then
    Result := 1
  else if TIndividuoOddface(a).adn = TIndividuoOddface(b).adn then
    Result := 0
  else
    Result := -1;
end;

{ T_fObjetivo_idx }

constructor T_fObjetivo_idx.Create;
begin
  inherited Create( true );
end;

function T_fObjetivo_idx.compare( a, b: TItemBTree ): integer;
var
  dif: double;
begin
  dif := TIndividuoOddface(a).f_Objetivo - TIndividuoOddface(b).f_Objetivo;
  if dif < 0 then
    Result := -1
  else if dif = 0 then
    Result := 0
  else
    Result := 1;
end;


end.


